 	ERRORLEVEL	0,	-302	;suppress bank selection messages
;	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _WRT_ENABLE_ON & _LVP_ON & _DEBUG_OFF & _CPD_OFF
        list p=16f636

        include "p16f636.inc"


temp		equ	0x20
Delay		equ	0x21		;Delay counter
Delay2		equ	0x22		;Delay counter 2
Delay3		equ 	0x23		;Delay counter 3
count		equ	0x24

bit_count		equ	0x25
Rec_byte		equ	0x26


#define	en	porta,1
#define	rs	porta,2


    ;Start at the reset vector
	;code for bootloader
	ORG 0x0000 ;reset vector 
;	clrf 0x3 ;zero status
;	movlw 0x00 ;high byte of long jump <<<these next 2 lines are important
;	movwf 0xA ;zero PCLATH
	goto start
	

;********************************************************************************************
;Setup up the delay routines that may be used
;delay of 1ms for 4mHz clock
Delay_1ms
	Movlw	D'166'	
	Movwf	Delay
delay_loop
	Nop
	Nop
	Nop
	Decfsz	Delay,f
	goto 	delay_loop
	return
;delay of 10ms for 4mHz clock
Delay_10ms
	movlw	d'10'
	movwf	Delay2
Delay_Loop_10ms	
	Call 	Delay_1ms		; Call 1ms delay	
	Decfsz	Delay2,f
	goto 	Delay_Loop_10ms
	return

;delay of 100ms for 4mHz clock
Delay_100ms
	movlw	d'100'
Delay_100x
	movwf	Delay2
Delay_Loop_100ms	
	Call 	Delay_1ms		; Call 1ms delay	
	Decfsz	Delay2,f
	goto 	Delay_Loop_100ms
	return

;delay of 1ms for 4mHz clock
Delay_1s
	movlw	d'10'
	movwf	Delay3
Delay_Loop_1s	
	Call 	Delay_100ms		; Call 100ms delay	
	Decfsz	Delay3,f
	goto 	Delay_Loop_1s
	return

Delay_52ns
	movlw   0x0C
        	movwf   Delay
Delay_52ns_loop 
	nop
        	decfsz  	Delay , f
        	goto    	Delay_52ns_loop
	return

Delay_104ns
	movlw   0x18
       	movwf   Delay
Delay_104ns_loop 
	nop
        	decfsz  	Delay , f
        	goto    	Delay_104ns_loop
	return



;********************************************************************************************
;initialize the display
initLCD
	movlw		d'20'
	movwf		delay2			;set up 20ms delay
	call		delay_loop_10ms
	bcf		rs
	bcf		en
	movlw		0x03
	movwf		portc
	bsf		en
	nop
	bcf		en
	movlw		d'5'
	movwf		delay2			;set up 5ms delay
	call		delay_loop_10ms

	movlw		0x03
	movwf		portc
	bsf		en
	nop
	bcf		en
	movlw		d'34'
	movwf		delay			;set up 200us delay
	call			delay_loop

	movlw		0x03
	movwf		portc
	bsf		en
	nop
	bcf		en
	movlw		d'34'
	movwf		delay			;set up 200us delay
	call		delay_loop

	movlw		0x02
	movwf		portc
	bsf		en
	nop
	bcf		en
	movlw		d'5'
	movwf		delay2			;set up 5ms delay
	call		delay_loop_10ms

	movlw		0x28	
	call		writecmd	
	movlw		0x08	
	call		writecmd
	movlw		0x01	
	call		writecmd
	movlw		0x06	
	call		writecmd
	movlw		0x0C
	call		writecmd
	return

;********************************************************************************************
writecmd
	movwf		temp        
	swapf		temp,W   
	movwf		portc       
	bcf		rs
 	bsf		en      
	nop	
	bcf		en
	movlw		0x05
	movwf		delay2			
	call		delay_loop_10ms
	movf		temp,W 
	movwf		portc     
	bcf		rs 
	bsf		en        
	nop
	bcf		en
	movlw		0x05
	movwf		delay2			
	call		delay_loop_10ms
	return
;********************************************************************************************
writechar
	movwf		temp        
	swapf		temp,W   
	movwf		portc    
	bsf		rs   
 	bsf		en          
	nop	
	bcf		en
	movlw		d'34'
	movwf		delay			;set up 200us delay
	call		delay_loop
	movf		temp,W 
	movwf		portc   
	bsf		rs   
	bsf		en      
	nop	
	bcf		en
	movlw		d'34'
	movwf		delay			;set up 200us delay
	call		delay_loop
	return
;********************************************************************************************
;********************************************************************************************
Start
	banksel		porta
	clrf		porta
	clrf		portc
	movlw		0x07
	movwf		cmcon0

	banksel		trisa
	clrf		portc	
	movlw		b'100001'
	movwf		porta
	
	movwf		wda
	movwf		wpuda

	movlw		b'100000'
	movwf		ioca
	bsf		intcon,RAIE		;enable interrupt on change
	bcf		intcon,T0IE		;disable TMR interrupt
	banksel		porta


	call		initlcd




;read our serial port baud 9800 8N1
; wait for the serial port to go high
Wait_for_high
	btfsc		porta,0	
	goto		Wait_for_High
	call		delay_52ns
	btfsc		porta,0
	goto		Wait_for_High
;read the next 8 bits

	movlw		0x08
	movwf		bit_count
	clrf		rec_byte
next_bit
	call		delay_104ns
	btfss		porta,0
	bcf		status,c
	btfsc		porta,0
	bsf		status,c
	rrf		rec_byte,1
	decfsz		bit_count,1
	goto		next_bit
	call		delay_104ns
	movfw		rec_byte

	sublw		d'31'
	btfss		status,C
	goto		printChar
	movfw		rec_byte
	call		writecmd
	goto		wait_for_high

PrintChar
	movfw		rec_byte
	call		writechar
	goto		wait_for_high





end